Index: drivers/at91/net/at91_ether.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/net/at91_ether.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/net/at91_ether.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/net/at91_ether.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -6,6 +6,9 @@
  * Based on an earlier Atmel EMAC macrocell driver by Atmel and Lineo Inc.
  * Initial version by Rick Bronson 01/11/2003
  *
+ * Intel LXT971A PHY support by Christopher Bahns & David Knickerbocker
+ *   (Polaroid Corporation)
+ *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version
@@ -55,10 +58,10 @@
  * Write value to the a PHY register
  * Note: MDI interface is assumed to already have been enabled.
  */
-static void write_phy(AT91PS_EMAC regs, unsigned char address, unsigned int value)
+static void write_phy(AT91PS_EMAC regs, unsigned char phy_addr, unsigned char address, unsigned int value)
 {
 	regs->EMAC_MAN = (AT91C_EMAC_HIGH | AT91C_EMAC_CODE_802_3 | AT91C_EMAC_RW_W
-		| (address << 18)) + (value & 0xffff);
+		| ((phy_addr & 0x1f) << 23) | (address << 18)) + (value & 0xffff);
 
 	/* Wait until IDLE bit in Network Status register is cleared */
 	// TODO: Enforce some maximum loop-count?
@@ -69,10 +72,10 @@
  * Read value stored in a PHY register.
  * Note: MDI interface is assumed to already have been enabled.
  */
-static void read_phy(AT91PS_EMAC regs, unsigned char address, unsigned int *value)
+static void read_phy(AT91PS_EMAC regs, unsigned char phy_addr, unsigned char address, unsigned int *value)
 {
 	regs->EMAC_MAN = AT91C_EMAC_HIGH | AT91C_EMAC_CODE_802_3 | AT91C_EMAC_RW_R
-		| (address << 18);
+		| ((phy_addr & 0x1f) << 23) | (address << 18);
 
 	/* Wait until IDLE bit in Network Status register is cleared */
 	// TODO: Enforce some maximum loop-count?
@@ -96,15 +99,15 @@
 	unsigned int speed, duplex;
 
 	/* Link status is latched, so read twice to get current value */
-	read_phy(regs, MII_BMSR, &bmsr);
-	read_phy(regs, MII_BMSR, &bmsr);
+	read_phy(regs, 0, MII_BMSR, &bmsr);
+	read_phy(regs, 0, MII_BMSR, &bmsr);
 	if (!(bmsr & BMSR_LSTATUS)) return -1;			/* no link */
 
-	read_phy(regs, MII_BMCR, &bmcr);
+	read_phy(regs, 0, MII_BMCR, &bmcr);
 	if (bmcr & BMCR_ANENABLE) {				/* AutoNegotiation is enabled */
 		if (!(bmsr & BMSR_ANEGCOMPLETE)) return -2;	/* auto-negotitation in progress */
 
-		read_phy(regs, MII_LPA, &lpa);
+		read_phy(regs, 0, MII_LPA, &lpa);
 		if ((lpa & LPA_100FULL) || (lpa & LPA_100HALF)) speed = SPEED_100;
 		else speed = SPEED_10;
 		if ((lpa & LPA_100FULL) || (lpa & LPA_10FULL)) duplex = DUPLEX_FULL;
@@ -135,16 +138,20 @@
 /*
  * Handle interrupts from the PHY
  */
-void at91ether_phy_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+static void at91ether_phy_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
 	struct net_device *dev = (struct net_device *) dev_id;
+	struct at91_private *lp = (struct at91_private *) dev->priv;
 	AT91PS_EMAC emac = (AT91PS_EMAC) dev->base_addr;
 	int status;
 	unsigned int phy;
 
 	enable_mdi(emac);
-
-	read_phy(emac, MII_DSINTR_REG, &phy);	/* acknowledge interrupt in PHY */
+	if (lp->phy_type == MII_DM9161_ID)
+		read_phy(emac, 0, MII_DSINTR_REG, &phy);	/* ack interrupt in Davicom PHY */
+	else if (lp->phy_type == MII_LXT971A_ID)
+		read_phy(emac, 0, MII_ISINTS_REG, &phy);	/* ack interrupt in Intel PHY */
+		
 	status = AT91_SYS->PIOC_ISR;		/* acknowledge interrupt in PIO */
 
 	status = update_linkspeed(dev, emac);
@@ -162,61 +169,103 @@
 /*
  * Initialize and enable the PHY interrupt when link-state changes
  */
-void enable_phyirq(struct net_device *dev, AT91PS_EMAC regs)
+static void enable_phyirq(struct net_device *dev, AT91PS_EMAC regs)
 {
 	struct at91_private *lp = (struct at91_private *) dev->priv;
 	unsigned int dsintr, status;
 
-	static int first_init = 0;
-
-	if (first_init == 0) {
-		// TODO: Check error code.  Really need a generic PIO (interrupt)
-		// layer since we're really only interested in the PC4 line.
-		(void) request_irq(4, at91ether_phy_interrupt, 0, dev->name, dev);
-
-		AT91_SYS->PIOC_ODR = AT91C_PIO_PC4;	/* Configure as input */
-
-		first_init = 1;
-	}
-	else {
-		status = AT91_SYS->PIOC_ISR;		/* clear any pending PIO interrupts */
-		AT91_SYS->PIOC_IER = AT91C_PIO_PC4;	/* Enable interrupt */
+	// TODO: Check error code.  Really need a generic PIO (interrupt)
+	// layer since we're really only interested in the PC4 (DK) or PC2 (CSB337) line.
+	(void) request_irq(AT91C_ID_PIOC, at91ether_phy_interrupt, 0, dev->name, dev);
+
+	status = AT91_SYS->PIOC_ISR;		/* clear any pending PIO interrupts */
+#ifdef CONFIG_MACH_CSB337
+	AT91_SYS->PIOC_IER = AT91C_PIO_PC2;	/* Enable interrupt */
+#else
+	AT91_SYS->PIOC_IER = AT91C_PIO_PC4;	/* Enable interrupt */
+#endif
 
-		spin_lock_irq(&lp->lock);
-		enable_mdi(regs);
-		read_phy(regs, MII_DSINTR_REG, &dsintr);
+	spin_lock_irq(&lp->lock);
+	enable_mdi(regs);
+		
+	if (lp->phy_type == MII_DM9161_ID) {		/* for Davicom PHY */
+		read_phy(regs, 0, MII_DSINTR_REG, &dsintr);
 		dsintr = dsintr & ~0xf00;		/* clear bits 8..11 */
-		write_phy(regs, MII_DSINTR_REG, dsintr);
-		disable_mdi(regs);
-		spin_unlock_irq(&lp->lock);
+		write_phy(regs, 0, MII_DSINTR_REG, dsintr);
+	}
+	else if (lp->phy_type == MII_LXT971A_ID) {	/* for Intel PHY */
+		read_phy(regs, 0, MII_ISINTE_REG, &dsintr);
+		dsintr = dsintr | 0xf2;			/* set bits 1, 4..7 */
+		write_phy(regs, 0, MII_ISINTE_REG, dsintr);
 	}
+		
+	disable_mdi(regs);
+	spin_unlock_irq(&lp->lock);
 }
 
 /*
  * Disable the PHY interrupt
  */
-void disable_phyirq(struct net_device *dev, AT91PS_EMAC regs)
+static void disable_phyirq(struct net_device *dev, AT91PS_EMAC regs)
 {
 	struct at91_private *lp = (struct at91_private *) dev->priv;
 	unsigned int dsintr;
 
 	spin_lock_irq(&lp->lock);
 	enable_mdi(regs);
-	read_phy(regs, MII_DSINTR_REG, &dsintr);
-	dsintr = dsintr | 0xf00;			/* set bits 8..11 */
-	write_phy(regs, MII_DSINTR_REG, dsintr);
+
+	if (lp->phy_type == MII_DM9161_ID) {		/* for Davicom PHY */
+		read_phy(regs, 0, MII_DSINTR_REG, &dsintr);
+		dsintr = dsintr | 0xf00;			/* set bits 8..11 */
+		write_phy(regs, 0, MII_DSINTR_REG, dsintr);
+	}
+	else if (lp->phy_type == MII_LXT971A_ID) {	/* for Intel PHY */
+		read_phy(regs, 0, MII_ISINTE_REG, &dsintr);
+		dsintr = dsintr & ~0xf2;			/* clear bits 1, 4..7 */
+		write_phy(regs, 0, MII_ISINTE_REG, dsintr);
+	}
+
 	disable_mdi(regs);
 	spin_unlock_irq(&lp->lock);
 
+#ifdef CONFIG_MACH_CSB337
+	AT91_SYS->PIOC_IDR = AT91C_PIO_PC2;		/* Disable interrupt */
+#else
 	AT91_SYS->PIOC_IDR = AT91C_PIO_PC4;		/* Disable interrupt */
+#endif
+	free_irq(AT91C_ID_PIOC, dev);			/* Free interrupt handler */
 }
 
+/*
+ * Perform a software reset of the PHY.
+ */
+static void reset_phy(struct net_device *dev, AT91PS_EMAC regs)
+{
+	struct at91_private *lp = (struct at91_private *) dev->priv;
+	unsigned int bmcr;
+
+	spin_lock_irq(&lp->lock);
+	enable_mdi(regs);
+
+	/* Perform PHY reset */
+	write_phy(regs, 0, MII_BMCR, BMCR_RESET);
+
+	/* Wait until PHY reset is complete */
+	do {
+		read_phy(regs, 0, MII_BMCR, &bmcr);
+	} while (!(bmcr && BMCR_RESET));
+
+	disable_mdi(regs);
+	spin_unlock_irq(&lp->lock);
+}
+
+
 /* ......................... ADDRESS MANAGEMENT ........................ */
 
 /*
  * Set the ethernet MAC address in dev->dev_addr
  */
-void get_mac_address(struct net_device *dev) {
+static void get_mac_address(struct net_device *dev) {
 	AT91PS_EMAC regs = (AT91PS_EMAC) dev->base_addr;
 	char addr[6];
 	unsigned int hi, lo;
@@ -342,7 +391,7 @@
 	AT91PS_EMAC regs = (AT91PS_EMAC) dev->base_addr;
 	unsigned int value;
 
-	read_phy(regs, location, &value);
+	read_phy(regs, phy_id, location, &value);
 	return value;
 }
 
@@ -350,7 +399,7 @@
 {
 	AT91PS_EMAC regs = (AT91PS_EMAC) dev->base_addr;
 
-	write_phy(regs, location, value);
+	write_phy(regs, phy_id, location, value);
 }
 
 /*
@@ -373,6 +422,10 @@
 	case ETHTOOL_GSET: {
 		struct ethtool_cmd ecmd = { ETHTOOL_GSET };
 		res = mii_ethtool_gset(&lp->mii, &ecmd);
+		if (lp->phy_media == PORT_FIBRE) {		/* override media type since mii.c doesn't know */
+			ecmd.supported = SUPPORTED_FIBRE;
+			ecmd.port = PORT_FIBRE;
+		}
 		if (copy_to_user(useraddr, &ecmd, sizeof(ecmd)))
 			res = -EFAULT;
 		break;
@@ -464,7 +517,7 @@
         	return -EADDRNOTAVAIL;
 
 	AT91_SYS->PMC_PCER = 1 << AT91C_ID_EMAC;	/* Re-enable Peripheral clock */
-	regs->EMAC_CTL |= AT91C_EMAC_CSR;	/* Clear internal statistics */
+	regs->EMAC_CTL |= AT91C_EMAC_CSR;		/* Clear internal statistics */
 
 	/* Enable PHY interrupt */
 	enable_phyirq(dev, regs);
@@ -659,11 +712,12 @@
 /*
  * Initialize the ethernet interface
  */
-static int at91ether_setup(struct net_device *dev)
+static int at91ether_setup(struct net_device *dev, unsigned long phy_type)
 {
 	struct at91_private *lp;
 	AT91PS_EMAC regs;
 	static int already_initialized = 0;
+	unsigned int val;
 
 	if (already_initialized)
 		return 0;
@@ -715,16 +769,30 @@
 	regs->EMAC_CTL = 0;
 
 #ifdef CONFIG_AT91_ETHER_RMII
-	regs->EMAC_CFG = AT91C_EMAC_RMII;
+	regs->EMAC_CFG = AT91C_EMAC_BIG | AT91C_EMAC_RMII;
 #else
-	regs->EMAC_CFG = 0;
+	regs->EMAC_CFG = AT91C_EMAC_BIG;
 #endif
+	if (phy_type == MII_LXT971A_ID)
+		regs->EMAC_CFG |= AT91C_EMAC_CLK_HCLK_64;	/* MDIO clock = system clock/64 */
+
+	if (phy_type == MII_DM9161_ID) {
+		spin_lock_irq(&lp->lock);
+		enable_mdi(regs);
+
+		read_phy(regs, 0, MII_DSCR_REG, &val);
+		if ((val & (1 << 10)) == 0)			/* DSCR bit 10 is 0 -- fiber mode */
+			lp->phy_media = PORT_FIBRE;
+
+		disable_mdi(regs);
+		spin_unlock_irq(&lp->lock);
+	}
 
 	lp->mii.dev = dev;		/* Support for ethtool */
 	lp->mii.mdio_read = mdio_read;
 	lp->mii.mdio_write = mdio_write;
-
-	enable_phyirq(dev, regs);
+	
+	lp->phy_type = phy_type;	/* Type of PHY connected */
 
 	/* Determine current link speed */
 	spin_lock_irq(&lp->lock);
@@ -740,6 +808,10 @@
 		regs->EMAC_CFG & AT91C_EMAC_FD ? "FullDuplex" : "HalfDuplex",
 		dev->dev_addr[0], dev->dev_addr[1], dev->dev_addr[2],
 		dev->dev_addr[3], dev->dev_addr[4], dev->dev_addr[5]);
+	if (phy_type == MII_DM9161_ID)
+		printk(KERN_INFO "%s: Davicom 9196 PHY %s\n", dev->name, (lp->phy_media == PORT_FIBRE) ? "(Fiber)" : "(Copper)");
+	else if (phy_type == MII_LXT971A_ID)
+		printk(KERN_INFO "%s: Intel LXT971A PHY\n", dev->name);
 
 	already_initialized = 1;
 	return 0;
@@ -748,7 +820,7 @@
 /*
  * Detect MAC and PHY and perform initialization
  */
-int at91ether_probe(struct net_device *dev)
+static int at91ether_probe(struct net_device *dev)
 {
 	AT91PS_EMAC regs = (AT91PS_EMAC) AT91C_VA_BASE_EMAC;
 	unsigned int phyid1, phyid2;
@@ -761,17 +833,22 @@
 	AT91_CfgPIO_EMAC_MII();
 #endif
 
+	AT91_CfgPIO_EMAC_PHY();				/* Configure PHY interrupt */
 	AT91_SYS->PMC_PCER = 1 << AT91C_ID_EMAC;	/* Enable Peripheral clock */
 
 	/* Read the PHY ID registers */
 	enable_mdi(regs);
-	read_phy(regs, MII_PHYSID1, &phyid1);
-	read_phy(regs, MII_PHYSID2, &phyid2);
+	read_phy(regs, 0, MII_PHYSID1, &phyid1);
+	read_phy(regs, 0, MII_PHYSID2, &phyid2);
 	disable_mdi(regs);
 
 	/* Davicom 9161: PHY_ID1 = 0x181  PHY_ID2 = B881 */
 	if (((phyid1 << 16) | (phyid2 & 0xfff0)) == MII_DM9161_ID) {
-		detected = at91ether_setup(dev);
+		detected = at91ether_setup(dev, MII_DM9161_ID);
+	}
+	/* Intel LXT971A: PHY_ID1 = 0x13  PHY_ID2 = 78E0 */
+	else if (((phyid1 << 16) | (phyid2 & 0xfff0)) == MII_LXT971A_ID) {
+		detected = at91ether_setup(dev, MII_LXT971A_ID);
 	}
 
 	AT91_SYS->PMC_PCDR = 1 << AT91C_ID_EMAC;	/* Disable Peripheral clock */
Index: drivers/at91/net/at91_ether.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/net/at91_ether.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/net/at91_ether.h	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/net/at91_ether.h	4 Aug 2004 01:28:37 -0000	1.2
@@ -22,9 +22,17 @@
 #define MII_DM9161_ID   0x0181b880
 
 /* Davicom specific registers */
+#define MII_DSCR_REG	16
 #define MII_DSCSR_REG   17
 #define MII_DSINTR_REG  21
 
+/* Intel LXT971A PHY */
+#define MII_LXT971A_ID	0x001378E0
+
+/* Intel specific registers */
+#define MII_ISINTE_REG	18
+#define MII_ISINTS_REG	19
+
 /* ........................................................................ */
 
 #define MAX_RBUFF_SZ	0x600		/* 1518 rounded up */
@@ -55,7 +63,9 @@
 	struct mii_if_info mii;			/* ethtool support */
 
 	/* PHY */
+	unsigned long phy_type;			/* type of PHY (PHY_ID) */
 	spinlock_t lock;			/* lock for MDI interface */
+	short phy_media;			/* media interface type */
 
 	/* Transmit */
 	struct sk_buff *skb;			/* holds skb until xmit interrupt completes */
Index: drivers/at91/rtc/at91_rtc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/rtc/at91_rtc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/rtc/at91_rtc.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/rtc/at91_rtc.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -94,7 +94,7 @@
 			| BIN2BCD(tval->tm_min) << 8
 			| BIN2BCD(tval->tm_hour) << 16;
 
-	AT91_SYS->RTC_CALR = BIN2BCD(tval->tm_year / 100)		/* century */
+	AT91_SYS->RTC_CALR = BIN2BCD((tval->tm_year + 1900) / 100)	/* century */
 	    		| BIN2BCD(tval->tm_year % 100) << 8	/* year */
 	    		| BIN2BCD(tval->tm_mon + 1) << 16	/* tm_mon starts at zero */
 	    		| BIN2BCD(tval->tm_wday + 1) << 21	/* day of the week [0-6], Sunday=0 */
@@ -180,7 +180,7 @@
 	return (rtc_irq_data) ? 0 : POLLIN | POLLRDNORM;
 }
 
-ssize_t at91_rtc_read(struct file * file, char *buf, size_t count, loff_t * ppos)
+static ssize_t at91_rtc_read(struct file * file, char *buf, size_t count, loff_t * ppos)
 {
 	DECLARE_WAITQUEUE(wait, current);
 	unsigned long data;
@@ -222,7 +222,6 @@
 out:
 	set_current_state(TASK_RUNNING);
 	remove_wait_queue(&at91_rtc_wait, &wait);
-	remove_wait_queue(&at91_rtc_update, &wait);
 	return retval;
 }
 
@@ -262,6 +261,7 @@
 		rtc_irq_data = 0;
 		break;
 	case RTC_ALM_READ:	/* read alarm */
+		memset(&tm, 0, sizeof(struct rtc_time));
 		at91_rtc_decodetime(&(AT91_SYS->RTC_TIMALR), &(AT91_SYS->RTC_CALALR), &tm);
 		tm.tm_yday = compute_yday(tm.tm_year, tm.tm_mon, tm.tm_mday);
 		tm.tm_year = at91_alarm_year - 1900;
@@ -290,6 +290,7 @@
 		}
 		break;
 	case RTC_RD_TIME:	/* read time */
+		memset(&tm, 0, sizeof(struct rtc_time));
 		at91_rtc_decodetime(&(AT91_SYS->RTC_TIMR), &(AT91_SYS->RTC_CALR), &tm);
 		tm.tm_yday = compute_yday(tm.tm_year, tm.tm_mon, tm.tm_mday);
 		tm.tm_year = tm.tm_year - 1900;
Index: drivers/at91/serial/at91_serial.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/serial/at91_serial.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/serial/at91_serial.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/serial/at91_serial.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -34,23 +34,9 @@
 #include <linux/sysrq.h>
 
 #include <asm/arch/AT91RM9200_USART.h>
+#include <asm/mach/serial_at91rm9200.h>
 #include <asm/arch/pio.h>
 
-/*
- * This is a temporary structure for registering these
- * functions; it is intended to be discarded after boot.
- */
-struct uart_port;
-struct uart_info;
-struct at91_port_fns {
-	void	(*set_mctrl)(struct uart_port *, u_int);
-	u_int	(*get_mctrl)(struct uart_port *);
-	void	(*enable_ms)(struct uart_port *);
-	void	(*pm)(struct uart_port *, u_int, u_int);
-	int	(*set_wake)(struct uart_port *, u_int);
-	int	(*open)(struct uart_port *, struct uart_info *);
-	void	(*close)(struct uart_port *, struct uart_info *);
-};
 
 #if defined(CONFIG_SERIAL_AT91_CONSOLE) && defined(CONFIG_MAGIC_SYSRQ)
 #define SUPPORT_SYSRQ
@@ -76,14 +62,26 @@
 #define UART_PUT_CHAR(port,v)	((AT91PS_USART)(port)->membase)->US_THR = v
 #define UART_GET_BRGR(port)	((AT91PS_USART)(port)->membase)->US_BRGR
 #define UART_PUT_BRGR(port,v)	((AT91PS_USART)(port)->membase)->US_BRGR = v
+#define UART_PUT_RTOR(port,v)	((AT91PS_USART)(port)->membase)->US_RTOR = v
 
 // #define UART_GET_CR(port)	((AT91PS_USART)(port)->membase)->US_CR		// is write-only
 
+ /* PDC registers */
+#define UART_PUT_PTCR(port,v)	((AT91PS_USART)(port)->membase)->US_PTCR = v
+#define UART_PUT_RPR(port,v)	((AT91PS_USART)(port)->membase)->US_RPR = v
+#define UART_PUT_RCR(port,v)	((AT91PS_USART)(port)->membase)->US_RCR = v
+#define UART_GET_RCR(port)	((AT91PS_USART)(port)->membase)->US_RCR
+#define UART_PUT_RNPR(port,v)	((AT91PS_USART)(port)->membase)->US_RNPR = v
+#define UART_PUT_RNCR(port,v)	((AT91PS_USART)(port)->membase)->US_RNCR = v
+
 static struct tty_driver normal, callout;
 static struct tty_struct *at91_table[AT91C_NR_UART];
 static struct termios *at91_termios[AT91C_NR_UART], *at91_termios_locked[AT91C_NR_UART];
-static int (*at91_open)(struct uart_port *, struct uart_info *);
-static void (*at91_close)(struct uart_port *, struct uart_info *);
+
+const int at91_serialmap[AT91C_NR_UART] = AT91C_UART_MAP;
+
+static int (*at91_open)(struct uart_port *);
+static void (*at91_close)(struct uart_port *);
 
 #ifdef SUPPORT_SYSRQ
 static struct console at91_console;
@@ -149,16 +147,14 @@
 /*
  * Start transmitting.
  */
-static void at91_start_tx(struct uart_port *port, u_int nonempty, u_int from_tty)
+static void at91_start_tx(struct uart_port *port, u_int from_tty)
 {
-	if (nonempty) {
-		unsigned long flags;
+	unsigned long flags;
 
-		local_irq_save(flags);
-		port->read_status_mask |= AT91C_US_TXRDY;
-		UART_PUT_IER(port, AT91C_US_TXRDY);
-		local_irq_restore(flags);
-	}
+	local_irq_save(flags);
+	port->read_status_mask |= AT91C_US_TXRDY;
+	UART_PUT_IER(port, AT91C_US_TXRDY);
+	local_irq_restore(flags);
 }
 
 /*
@@ -191,10 +187,10 @@
 /*
  * Characters received (called from interrupt handler)
  */
-static void at91_rx_chars(struct uart_info *info, struct pt_regs *regs)
+static void at91_rx_chars(struct uart_port *port, struct pt_regs *regs)
 {
+	struct uart_info *info = port->info;
 	struct tty_struct *tty = info->tty;
-	struct uart_port *port = info->port;
 	unsigned int status, ch, flg, ignored = 0;
 
 	status = UART_GET_CSR(port);
@@ -214,7 +210,7 @@
 		if (status & (AT91C_US_PARE | AT91C_US_FRAME | AT91C_US_OVRE))
 			goto handle_error;
 
-		if (uart_handle_sysrq_char(info, ch, regs))
+		if (uart_handle_sysrq_char(port, ch, regs))
 			goto ignore_char;
 
 	error_return:
@@ -266,7 +262,7 @@
 		flg = TTY_OVERRUN;
 	}
 #ifdef SUPPORT_SYSRQ
-	info->sysrq = 0;
+	port->sysrq = 0;
 #endif
 	goto error_return;
 }
@@ -274,9 +270,9 @@
 /*
  * Transmit characters (called from interrupt handler)
  */
-static void at91_tx_chars(struct uart_info *info)
+static void at91_tx_chars(struct uart_port *port)
 {
-	struct uart_port *port = info->port;
+	struct circ_buf *xmit = &port->info->xmit;
 
 	if (port->x_char) {
 		UART_PUT_CHAR(port, port->x_char);
@@ -284,26 +280,24 @@
 		port->x_char = 0;
 		return;
 	}
-	if (info->xmit.head == info->xmit.tail
-	    || info->tty->stopped
-	    || info->tty->hw_stopped) {
-		at91_stop_tx(info->port, 0);
+	if (uart_circ_empty(xmit) || uart_tx_stopped(port)) {
+		at91_stop_tx(port, 0);
 		return;
 	}
 
 	while (UART_GET_CSR(port) & AT91C_US_TXRDY) {
-		UART_PUT_CHAR(port, info->xmit.buf[info->xmit.tail]);
-		info->xmit.tail = (info->xmit.tail + 1) & (UART_XMIT_SIZE - 1);
+		UART_PUT_CHAR(port, xmit->buf[xmit->tail]);
+		xmit->tail = (xmit->tail + 1) & (UART_XMIT_SIZE - 1);
 		port->icount.tx++;
-		if (info->xmit.head == info->xmit.tail)
+		if (uart_circ_empty(xmit))
 			break;
 	}
 
-	if (CIRC_CNT(info->xmit.head, info->xmit.tail, UART_XMIT_SIZE) < WAKEUP_CHARS)
-		uart_event(info, EVT_WRITE_WAKEUP);
+	if (uart_circ_chars_pending(xmit) < WAKEUP_CHARS)
+		uart_write_wakeup(port);
 
-	if (info->xmit.head == info->xmit.tail)
-		at91_stop_tx(info->port, 0);
+	if (uart_circ_empty(xmit))
+		at91_stop_tx(port, 0);
 }
 
 /*
@@ -311,8 +305,7 @@
  */
 static void at91_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
-	struct uart_info *info = dev_id;
-	struct uart_port *port = info->port;
+	struct uart_port *port = dev_id;
 	unsigned int status, pending, pass_counter = 0;
 
 	status = UART_GET_CSR(port);
@@ -320,15 +313,15 @@
 	if (pending) {
 		do {
 			if (pending & AT91C_US_RXRDY)
-				at91_rx_chars(info, regs);
+				at91_rx_chars(port, regs);
 
 			/* Clear the relevent break bits */
 			if (pending & AT91C_US_RXBRK) {
 				UART_PUT_CR(port, AT91C_US_RSTSTA);
 				port->icount.brk++;
 #ifdef SUPPORT_SYSRQ
-				if (port->line == at91_console.index && !info->sysrq) {
-					info->sysrq = jiffies + HZ*5;
+				if (port->line == at91_console.index && !port->sysrq) {
+					port->sysrq = jiffies + HZ*5;
 				}
 #endif
 			}
@@ -338,17 +331,17 @@
 			if (pending & AT91C_US_DSRIC) port->icount.dsr++;
 			if (pending & AT91C_US_DCDIC) {
 				port->icount.dcd++;
-				uart_handle_dcd_change(info, status & AT91C_US_DCD);
+				uart_handle_dcd_change(port, status & AT91C_US_DCD);
 			}
 			if (pending & AT91C_US_CTSIC) {
 				port->icount.cts++;
-				uart_handle_cts_change(info, status & AT91C_US_CTS);
+				uart_handle_cts_change(port, status & AT91C_US_CTS);
 			}
 			if (pending & (AT91C_US_RIIC | AT91C_US_DSRIC | AT91C_US_DCDIC | AT91C_US_CTSIC))
-				wake_up_interruptible(&info->delta_msr_wait);
+				wake_up_interruptible(&port->info->delta_msr_wait);
 
 			if (pending & AT91C_US_TXRDY)
-				at91_tx_chars(info);
+				at91_tx_chars(port);
 			if (pass_counter++ > AT91_ISR_PASS_LIMIT)
 				break;
 
@@ -361,14 +354,14 @@
 /*
  * Perform initialization and enable port for reception
  */
-static int at91_startup(struct uart_port *port, struct uart_info *info)
+static int at91_startup(struct uart_port *port)
 {
 	int retval;
 
 	/*
 	 * Allocate the IRQ
 	 */
-	retval = request_irq(port->irq, at91_interrupt, SA_SHIRQ, "at91_serial", info);
+	retval = request_irq(port->irq, at91_interrupt, SA_SHIRQ, "at91_serial", port);
 	if (retval) {
 		printk("at91_serial: at91_startup - Can't get irq\n");
 		return retval;
@@ -378,9 +371,9 @@
 	 * control line interrupts)
 	 */
 	if (at91_open) {
-		retval = at91_open(port, info);
+		retval = at91_open(port);
 		if (retval) {
-			free_irq(port->irq, info);
+			free_irq(port->irq, port);
 			return retval;
 		}
 	}
@@ -403,19 +396,19 @@
 /*
  * Disable the port
  */
-static void at91_shutdown(struct uart_port *port, struct uart_info *info)
+static void at91_shutdown(struct uart_port *port)
 {
 	/*
 	 * Free the interrupt
 	 */
-	free_irq(port->irq, info);
+	free_irq(port->irq, port);
 
 	/*
 	 * If there is a specific "close" function (to unregister
 	 * control line interrupts)
 	 */
 	if (at91_close)
-		at91_close(port, info);
+		at91_close(port);
 
 	/*
 	 * Disable all interrupts, port and break condition.
@@ -428,6 +421,8 @@
 		AT91_SYS->PMC_PCDR = 1 << port->irq;
 }
 
+static struct uart_ops at91_pops;		/* forward declaration */
+
 /*
  * Change the port parameters
  */
@@ -461,7 +456,13 @@
 
 	/* parity */
 	if (cflag & PARENB) {
-		if (cflag & PARODD)
+		if (cflag & CMSPAR) {			/* Mark or Space parity */
+			if (cflag & PARODD)
+				mode |= AT91C_US_PAR_MARK;
+			else
+				mode |= AT91C_US_PAR_SPACE;
+		}
+		else if (cflag & PARODD)
 			mode |= AT91C_US_PAR_ODD;
 		else
 			mode |= AT91C_US_PAR_EVEN;
@@ -512,6 +513,10 @@
 
 	/* restore interrupts */
 	UART_PUT_IER(port, imr);
+
+	/* CTS flow-control and modem-status interrupts */
+	if (UART_ENABLE_MS(port, cflag))
+		at91_pops.enable_ms(port);
 }
 
 /*
@@ -597,7 +602,26 @@
 
 static struct uart_port at91_ports[AT91C_NR_UART];
 
-void __init at91_register_uart_fns(struct at91_port_fns *fns)
+void __init at91_init_ports(void)
+{
+	static int first = 1;
+	int i;
+
+	if (!first)
+		return;
+	first = 0;
+
+	for (i = 0; i < AT91C_NR_UART; i++) {
+		at91_ports[i].iotype	= SERIAL_IO_MEM;
+		at91_ports[i].flags     = ASYNC_BOOT_AUTOCONF;
+		at91_ports[i].uartclk   = AT91C_MASTER_CLOCK;
+		at91_ports[i].ops	= &at91_pops;
+		at91_ports[i].fifosize  = 1;
+		at91_ports[i].line	= i;
+ 	}
+}
+
+void __init at91_register_uart_fns(struct at91rm9200_port_fns *fns)
 {
 	if (fns->enable_ms)
 		at91_pops.enable_ms = fns->enable_ms;
@@ -621,12 +645,6 @@
 		return;
 	}
 
-	at91_ports[idx].iotype   = SERIAL_IO_MEM;
-	at91_ports[idx].flags    = ASYNC_BOOT_AUTOCONF;
-	at91_ports[idx].uartclk  = AT91C_MASTER_CLOCK;
-	at91_ports[idx].ops      = &at91_pops;
-	at91_ports[idx].fifosize = 0;
-
 	switch (port) {
 	case 0:
 		at91_ports[idx].membase = (void *) AT91C_VA_BASE_US0;
@@ -665,10 +683,6 @@
 
 #ifdef CONFIG_SERIAL_AT91_CONSOLE
 
-#ifndef CONFIG_AT91_DEFAULT_BAUDRATE
-#define CONFIG_AT91_DEFAULT_BAUDRATE	115200
-#endif
-
 /*
  * Interrupts are disabled on entering
  */
@@ -720,9 +734,11 @@
  */
 static void __init at91_console_get_options(struct uart_port *port, int *baud, int *parity, int *bits)
 {
-	unsigned int cr, mr, quot;
+	unsigned int mr, quot;
 
 // TODO: CR is a write-only register
+//	unsigned int cr;
+//
 //	cr = UART_GET_CR(port) & (AT91C_US_RXEN | AT91C_US_TXEN);
 //	if (cr == (AT91C_US_RXEN | AT91C_US_TXEN)) {
 //		/* ok, the port was enabled */
@@ -749,7 +765,7 @@
 static int __init at91_console_setup(struct console *co, char *options)
 {
 	struct uart_port *port;
-	int baud = CONFIG_AT91_DEFAULT_BAUDRATE;
+	int baud = AT91C_CONSOLE_DEFAULT_BAUDRATE;
 	int bits = 8;
 	int parity = 'n';
 	int flow = 'n';
@@ -785,6 +801,7 @@
 
 void __init at91_console_init(void)
 {
+	at91_init_ports();
 	register_console(&at91_console);
 }
 
@@ -810,17 +827,36 @@
 	termios_locked:		at91_termios_locked,
 	minor:			MINOR_START,
 	nr:			AT91C_NR_UART,
-	port:			at91_ports,
 	cons:			AT91_CONSOLE_DEVICE,
 };
 
 static int __init at91_serial_init(void)
 {
-	return uart_register_driver(&at91_reg);
+	int ret, i;
+
+	at91_init_ports();
+
+	ret = uart_register_driver(&at91_reg);
+	if (ret)
+		return ret;
+
+	for (i = 0; i < AT91C_NR_UART; i++) {
+		if (at91_serialmap[i] >= 0)
+			uart_add_one_port(&at91_reg, &at91_ports[i]);
+	}
+
+	return 0;
 }
 
 static void __exit at91_serial_exit(void)
 {
+	int i;
+
+	for (i = 0; i < AT91C_NR_UART; i++) {
+ 		if (at91_serialmap[i] >= 0)
+			uart_remove_one_port(&at91_reg, &at91_ports[i]);
+  	}
+
 	uart_unregister_driver(&at91_reg);
 }
 
Index: drivers/at91/spi/at91_spi.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/spi/at91_spi.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/spi/at91_spi.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/spi/at91_spi.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -30,7 +30,7 @@
 DECLARE_COMPLETION(transfer_complete);
 
 /* SPI controller device */
-AT91PS_SPI controller = (AT91PS_SPI) AT91C_VA_BASE_SPI;
+static AT91PS_SPI controller = (AT91PS_SPI) AT91C_VA_BASE_SPI;
 
 /* ......................................................................... */
 
@@ -171,7 +171,7 @@
 /*
  * Handle interrupts from the SPI controller.
  */
-void spi_interrupt(int irq, void *dev_id, struct pt_regs *regs)
+static void spi_interrupt(int irq, void *dev_id, struct pt_regs *regs)
 {
  	unsigned int status;
 	struct spi_local *device = (struct spi_local *) &spi_dev[current_device];
Index: drivers/at91/spi/at91_spidev.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/spi/at91_spidev.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/spi/at91_spidev.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/spi/at91_spidev.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -112,7 +112,7 @@
 	return res;
 }
 
-int spidev_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
+static int spidev_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long arg)
 {
 	int spi_device = MINOR(inode->i_rdev);
 
@@ -131,7 +131,7 @@
 /*
  * Open the SPI device
  */
-int spidev_open(struct inode *inode, struct file *file)
+static int spidev_open(struct inode *inode, struct file *file)
 {
 	unsigned int spi_device = MINOR(inode->i_rdev);
 
@@ -205,7 +205,7 @@
 /*
  * Remove the SPI /dev interface driver
  */
-static void at91_spidev_exit(void)
+static void __exit at91_spidev_exit(void)
 {
 #ifdef CONFIG_DEVFS_FS
 	devfs_unregister(devfs_handle);
Index: drivers/at91/usb/at91_usb-ohci.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/usb/at91_usb-ohci.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/usb/at91_usb-ohci.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/usb/at91_usb-ohci.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -46,6 +46,10 @@
 		return -EIO;
 	}
 
+	/* Enable PLLB */
+	AT91_SYS->CKGR_PLLBR = AT91_PLLB_INIT;
+	while ((AT91_SYS->PMC_SR & 4) == 0);
+
 	/* Now, enable the USB clock */
 	AT91_SYS->PMC_SCER = AT91C_PMC_UHP;	/* enable system clock */
 	AT91_SYS->PMC_PCER = 1 << AT91C_ID_UHP;	/* enable peripheral clock */
Index: drivers/at91/watchdog/at91_wdt.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/at91/watchdog/at91_wdt.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/at91/watchdog/at91_wdt.c	22 Jul 2004 19:49:50 -0000	1.1
+++ drivers/at91/watchdog/at91_wdt.c	4 Aug 2004 01:28:37 -0000	1.2
@@ -27,7 +27,7 @@
 /*
  * Disable the watchdog.
  */
-void at91_wdt_stop(void)
+static void at91_wdt_stop(void)
 {
 	AT91_SYS->ST_WDMR = AT91C_ST_EXTEN;
 }
@@ -35,7 +35,7 @@
 /*
  * Enable and reset the watchdog.
  */
-void at91_wdt_start(void)
+static void at91_wdt_start(void)
 {
 	AT91_SYS->ST_WDMR = AT91C_ST_EXTEN | AT91C_ST_RSTEN | (((65536 * at91wdt_time) >> 8) & AT91C_ST_WDV);
 	AT91_SYS->ST_CR = AT91C_ST_WDRST;
